(defun c:otm (/
              *error* ;_  
              vk_modes
              vk_moder
              mode1 ;_  sysvars
              vscale ;_   
              doc ;_   (vla-)
              nuly ;_  Y  
              dimlf ;_    DIMLFAC
              bname ;_  
              tmp ;_  
              pt ;_  
              ypt ;_ Y  
              xipt ;_ X   
              layget ;_    
              m ;_  
              gdx1 ;_   
              gdx2
              gdx3
              gdx4
              gdy1
              gdy2
              gdy3
              ln ;_    
              lc ;_  
              scale ;_  . 
             )
  (setq ln "")
  (setq lc 4)
  (setq scale 0.001) ;_ 0.001 =   ,    
  (setq dimlf (getvar "dimlfac")) ;_  .  (  ,   = 1)

  ;;--------------------------------------------------------------------------
  ;;  
  (defun *error* (s)
    (if (null (member s '("Function cancelled" "quit / exit abort")))
      (princ (strcat "\nError: " s " " (rtos (getvar "errno") 2 0)))
    ) ;_  if
    (vla-endundomark doc)               ;   UNDO
    (redraw)
    (vl-cmdf "_.u")                     ;   
    (princ)                             ;  
  ) ;_  defun

  ;;--------------------------------------------------------------------------
  ;;   
  ;;  ,    (_1 _1 _2 _2 ....)
  (defun vk_modes (listvar / ms) ;_ listvar -   
    (foreach n listvar (setq ms (cons (getvar n) (cons n ms))))
    (reverse ms)
  ) ;_  defun

  ;;--------------------------------------------------------------------------
  ;;   
  (defun vk_moder (ms) ;_ ms - ,    (_1 _1 _2 _2 ....)
    (while ms (setvar (car ms) (cadr ms)) (setq ms (cddr ms))) ;_  while
  ) ;_  defun

  ;;==========================================================================================
  ;;        ***   ***
  (setq doc (vla-get-activedocument (vlax-get-acad-object)))
  (vla-startundomark doc)               ;      _.U
  (setq mode1 ;_  
         (vk_modes '("cmdecho" "blipmode" "clayer" "pickfirst" "dimzin" "orthomode" "snapmode" "attreq"))
  ) ;_  setq
  (setvar "cmdecho" 0)
  (if (setq layget (tblsearch "LAYER" ln)) ;    
    (cond                               ;  ,    
      ((= (logand 1 (cdr (assoc 70 layget))) 1)
       (alert (strcat " \"" ln "\", !\n\n , , ..."))
       (exit)
      )
      ((= (logand 4 (cdr (assoc 70 layget))) 4)
       (alert (strcat " \"" ln "\" !\n\n , , ..."))
       (exit)
      )
      ((minusp (cdr (assoc 62 layget)))
       (alert (strcat "!!!\n\n \"" ln "\",     , !"))
      )
    ) ;_  cond
    (vl-cmdf "_.layer" "_n" ln "_c" lc ln "") ;  ,   
  ) ;_  if

  (vk_moder (list "cmdecho"             ;  
                  0
                  "blipmode"
                  0
                  "clayer"              ;  
                  ln
                  "pickfirst"           ;   
                  0
                  "dimzin"
                  0
                  "orthomode"
                  0
                  "snapmode"
                  0
                  "attreq"
                  1
            ) ;_  list
  ) ;_  vk_moder

  (if (null (setq nuly (vl-bb-ref 'otm:nuly)))
    (setq nuly 0.0)
  ) ;_  if
  (if (setq tmp (getpoint (strcat "\n   <" (rtos nuly 2 3) ">")))
    (setq nuly (cadr tmp))
  ) ;_  if
  ;|      ,
      (if...) 
   (),   
    (setq nuly 0.0)
     
    (vl-bb-set 'otm:nuly nuly)
        () |;

  (grdraw (list -1e7 nuly) (list 1e7 nuly) 1) ;     

  (initget 1)
  (setq pt (getpoint "\n   >"))
  (setq ypt (cadr pt))

  ;;      1  Model  Layout
  (setq vscale (if (and (= (getvar "tilemode") 0) (/= (caar (vports)) 1))
                 (vla-get-customscale (vla-get-activepviewport doc)) ;   
                 1.0                    ;  Model  Layout   = 1
               ) ;_  if
  ) ;_  setq

  (princ "\n  >")
  (initget 1)

  ;;   
  (while (/= (car (setq m (grread t 4 1))) 3)
    (if (= (car m) 5)                   ;   
      (progn                            ;  
        (setq tmp (cadr m))             ;  
        (redraw)
        (grdraw (list -1e7 nuly) (list 1e7 nuly) 1) ;     
        (if (< ypt (cadr tmp))
          (setq gdy1 (cadr pt)
                gdy2 (+ (cadr pt) (/ 5.5 vscale))
                gdy3 (+ (cadr pt) (/ 9 vscale))
          ) ;_  setq
          (setq gdy1 (cadr pt)
                gdy2 (- (cadr pt) (/ 3 vscale))
                gdy3 (- (cadr pt) (/ 6.5 vscale))
          ) ;_  setq
        ) ;_  if
        (if (< (car pt) (car tmp))
          (setq gdx1 (car tmp)
                gdx2 (+ (car tmp) (/ 10 vscale))
                gdx3 (+ (car tmp) (/ 13 vscale))
                gdx4 (+ (car tmp) (/ 25 vscale))
          ) ;_  setq
          (setq gdx1 (car tmp)
                gdx2 (- (car tmp) (/ 10 vscale))
                gdx3 (- (car tmp) (/ 13 vscale))
                gdx4 (- (car tmp) (/ 25 vscale))
          ) ;_  setq
        ) ;_  if
        (grvecs (list 5                 ; 
                      (list gdx1 gdy1)  ;  
                      (list gdx3 gdy1)
                      1
                      (list gdx2 gdy1)  ;  
                      (list gdx2 gdy3)
                      (list gdx2 gdy3)
                      (list gdx4 gdy3)
                      (list gdx4 gdy3)
                      (list gdx4 gdy2)
                      (list gdx4 gdy2)
                      (list gdx2 gdy2)
                ) ;_  list
        ) ;_  grvecs
      ) ;_  progn
    ) ;_  if
  ) ;_  while

  (setq xipt (car (setq tmp (cadr m)))) ;    

  ;;        
  (setq bname (strcat (if (< ypt (cadr tmp))
                        "t"
                        "b"
                      ) ;_  if
                      (if (< (car pt) xipt)
                        "r"
                        "l"
                      ) ;_  if
              ) ;_  strcat
  ) ;_  setq

  ;;         
  (initget 0)
  (if (null
        (setq tmp (getreal (strcat "\n  <" (rtos (* (- ypt nuly) dimlf scale) 2 3) ">")))
      ) ;_  null
    (setq tmp (* (- ypt nuly) dimlf scale))
  ) ;_  if
  ;|     ,    (if....)
    (),   
  (setq tmp (* (- ypt nuly) dimlf scale))    |;

  ;;  
  (command "_insert"
           bname
           "_non"
           (list xipt ypt)
           (/ 1 vscale)
           (/ 1 vscale)
           0.0
           (strcat (cond ((zerop tmp) "%%p")
                         ((minusp tmp) "")
                         (t "+")
                   ) ;_  cond
                   (rtos tmp 2 3)
           ) ;_  strcat
  ) ;_  command

  (vl-bb-set 'otm:nuly nuly)
  (vk_moder mode1)                      ;  
  (redraw)
  (vla-endundomark doc)                 ;   UNDO
  (princ)
) ;_  defun
(vl-load-com)
(princ "\n  ")
(princ "\n2003   e-mail: vkle@saminfo.ru")
(princ "\n   : OTM")

